if (not EZBlizzardUiPopupsTooltip) then
	CreateFrame("GameTooltip", "EZBlizzardUiPopupsTooltip", UIParent, "GameTooltipTemplate")
	EZBlizzardUiPopupsTooltip:SetFrameStrata("TOOLTIP")
	EZBlizzardUiPopupsTooltip:Hide()
end

function EZBlizzardUiPopups_PlaySound(soundID)
	if soundID then
		PlaySound(soundID, "master")
	end
end

-- Tip by Gello - Hyjal
-- takes an npcID and returns the name of the npc
function EZBlizzardUiPopups_GetNameFromNpcID(npcID)
	local name = ""
	
	EZBlizzardUiPopupsTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	EZBlizzardUiPopupsTooltip:SetHyperlink(format("unit:Creature-0-0-0-0-%d-0000000000", npcID))
	
	local line = _G[("EZBlizzardUiPopupsTooltipTextLeft%d"):format(1)]
	if line and line:GetText() then
		name = line:GetText()
	end
	
	return name
end

-- TOASTS - Thanks to Tuhljin from Overachiever !
-----------

--local function alertOnClick(self, ...)
function EZBlizzardUiPopups_AlertFrame_OnClick(self, ...)
	if (self.delay == -1) then
		self:SetScript("OnLeave", AlertFrame_ResumeOutAnimation)
		self.delay = 0
	end
	if (self.onClick) then
		if (AlertFrame_OnClick(self, ...)) then  return;  end -- Handle right-clicking to hide the frame.
		self.onClick(self, ...)
	elseif (self.onClick == false) then
		AlertFrame_OnClick(self, ...)
	else
		AchievementAlertFrame_OnClick(self, ...)
	end
end

local function EZBlizzardUiPopups_AlertFrame_SetUp(frame, achievementID, alreadyEarned, name, delay, toptext, onClick, icon)
	-- An alert flagged as alreadyEarned has more space for the text to display since there's no shield+points icon.
	local ret = AchievementAlertFrame_SetUp(frame, achievementID, alreadyEarned)
	frame.Name:SetText(name)
	frame.Unlocked:SetText(toptext or (toptext == false and THIS_TITLE) or ACHIEVEMENT_UNLOCKED)
	frame.onClick = onClick
	frame.delay = delay
	frame:SetScript("OnClick", EZBlizzardUiPopups_AlertFrame_OnClick)
	if (delay) then
		if (delay <= 0) then
			C_Timer.After(0, function()  AlertFrame_StopOutAnimation(frame);  end)
		else
			C_Timer.After(0, function()
				frame.waitAndAnimOut.animOut:SetStartDelay(delay)
			end)
		end
	end
	if (delay == -1) then
		frame:SetScript("OnLeave", nil)
	else
		frame:SetScript("OnLeave", AlertFrame_ResumeOutAnimation)
	end
	if (icon) then
		--HEY = HEY or { frame.Icon.Texture:GetTexCoord() }
		frame.Icon.Texture:SetTexture(icon)
		frame.Icon.Texture:SetTexCoord(0.0, 0.7109375, 0.0, 0.7109375)
		frame.Background:SetTexture(TexAlert)
		frame.OldAchievement:SetTexture(TexAlertBorders)
	else
		frame.Icon.Texture:SetTexCoord(0, 0, 0, 1, 1, 0, 1, 1)
		frame.Background:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Alert-Background")
		frame.OldAchievement:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Borders")
	end
end

function EZBlizzardUiPopups_ToastFakeAchievement(addon, name, baseID, playSound, delay, toptext, onClick, icon, newEarn)
  if AchievementFrame_LoadUI then
	  if (IsKioskModeEnabled()) then
		return;
	  end
	  if ( not AchievementFrame ) then
		AchievementFrame_LoadUI();
	  end

	  if (not addon.AlertSystem) then
		addon.AlertSystem = AlertFrame:AddQueuedAlertFrameSubSystem("AchievementAlertFrameTemplate", EZBlizzardUiPopups_AlertFrame_SetUp, 4, math.huge)
	  end

	  if (not baseID) then  baseID = 5208;  end -- 5208 is "Twin Peaking", chosen because of its thumbs-up texture.
	  addon.AlertSystem:AddAlert(baseID, not newEarn, name, delay, toptext, onClick, icon)

	  if (playSound) then EZBlizzardUiPopups_PlaySound(12891);  end -- UI_Alert_AchievementGained
  end
end

-- NPC dialog pop-up
-----------
local firstNPCDialog = true

local npcModels = {
	["BAINE"]                 = { ["CreatureId"] = 36648,  ["CameraId"] = 126 },
	["SYLVANAS"]              = { ["CreatureId"] = 10181,  ["CameraId"] = 84 },
	["ANDUIN"]                = { ["CreatureId"] = 107574, ["CameraId"] = 82 },
	["ALLIANCE_GUILD_HERALD"] = { ["CreatureId"] = 49587,  ["CameraId"] = 82 },
	["VARIAN"]                = { ["CreatureId"] = 29611,  ["CameraId"] = 82 },
	["HEMET"]                 = { ["CreatureId"] = 94409,  ["CameraId"] = 90 },
	["RAVERHOLDT"]            = { ["CreatureId"] = 101513, ["CameraId"] = 82 },
	["UTHER"]                 = { ["CreatureId"] = 17233,  ["CameraId"] = 82 },
	["VELEN"]                 = { ["CreatureId"] = 17468,  ["CameraId"] = 106},
	["NOBUNDO"]               = { ["CreatureId"] = 110695, ["CameraId"] = 268},
	["KHADGAR"]               = { ["CreatureId"] = 90417,  ["CameraId"] = 82 },
	["CHOGALL"]               = { ["CreatureId"] = 81822,  ["CameraId"] = 815},
	["CHEN"]                  = { ["CreatureId"] = 56133,  ["CameraId"] = 144},
	["MALFURION"]             = { ["CreatureId"] = 102432, ["CameraId"] = 99 },
	["ILLIDAN"]               = { ["CreatureId"] = 22917,  ["CameraId"] = 296},
	["LICH_KING"]             = { ["CreatureId"] = 36597,  ["CameraId"] = 88 },
	["HORDE_GUILD_HERALD"]    = { ["CreatureId"] = 49590,  ["CameraId"] = 141},
	["THRALL"]                = { ["CreatureId"] = 91731,  ["CameraId"] = 815},
	["GALLYWIX"]              = { ["CreatureId"] = 101605, ["CameraId"] = 114}
}

function EZBlizzardUiPopups_npcDialog(npc, text)
	local frame = nil
	if TalkingHead_LoadUI then
		if firstNPCDialog then
			EZBlizzardUiPopups_npcDialogShow(npc, text)
			firstNPCDialog = false
		end
		frame = EZBlizzardUiPopups_npcDialogShow(npc, text)
	end
	return frame
end

function EZBlizzardUiPopups_npcDialogShow(npc, text)
	local frame = nil
	if text then
		if ( not TalkingHeadFrame ) then
			TalkingHead_LoadUI()
		end

		frame = TalkingHeadFrame
		
		local model = frame.MainFrame.Model
		model:ClearModel()
		model:SetCreature(npcModels[npc]["CreatureId"])
		--model:SetDisplayInfo(npcModels[npc]["CreatureId"])
		EZBlizzardUiPopups_TalkingHeadFrame_Play(npcModels[npc]["CameraId"], EZBlizzardUiPopups_GetNameFromNpcID(npcModels[npc]["CreatureId"]), text)

	end
	return frame
end

function EZBlizzardUiPopups_TalkingHeadFrame_Play(cameraId, name, text)
	local frame = TalkingHeadFrame
	local model = frame.MainFrame.Model
	
	--local currentDisplayInfo = model:GetDisplayInfo()
	local textFormatted = string.format(text)
	frame:Show()
	model.uiCameraID = cameraId
	Model_ApplyUICamera(model, model.uiCameraID)

	TalkingHeadFrame_Reset(frame, textFormatted, name)
	TalkingHeadFrame_FadeinFrames()
end

--[[
local camId = 82

for i = 0, 0 do
	for j = 0, 11 do
		local totopModel = CreateFrame("PlayerModel", "", UIParent)
		totopModel:SetPoint("TOPLEFT", i*80, -j*80 - 30)
		totopModel:SetWidth(80)
		totopModel:SetHeight(80)
		totopModel:SetCreature(10181)
		Model_ApplyUICamera(totopModel, camId)
		local fontstring = totopModel:CreateFontString("", "ARTWORK", "GameTooltipText")
		fontstring:SetTextColor(1, 1, 1, 1.0)
		fontstring:SetText(camId)
		fontstring:SetPoint("BOTTOM", 0, 0)
		camId = camId + 1
	end
end
--]]

--[[



	local totopModel = CreateFrame("PlayerModel", "", UIParent)
	totopModel:SetPoint("CENTER", 0, 0)
	totopModel:SetWidth(200)
	totopModel:SetHeight(200)
	totopModel:SetCreature(107574)
	totopModel:SetCamDistanceScale(1.5)
	totopModel:SetPortraitZoom(1)
	totopModel:SetRotation(-0.3)

--]]

-- Loading models
local model = CreateFrame('PlayerModel', nil, UIParent)
for index,value in pairs(npcModels) do
	model:SetCreature(npcModels[index]["CreatureId"])
end
model:Hide()
